//
//  TestDiskController.h
//  RecoveRx
//
//  Created by Sendoh Chen on 2014/7/10.
//
//

#ifndef RecoveRx_TestDiskController_h
#define RecoveRx_TestDiskController_h

#define MAX_DISK_NAME_LEN       8
#define MAX_PATH_LEN            1024
#define MAX_FILE_TYPE_COUNT     512
#define MAX_FILE_TYPE_STR_LEN   20

#define MAX_BUF_LEN             32

typedef enum { RECOVERY_PSTATUS_OK=0, RECOVERY_PSTATUS_STOP=1, RECOVERY_PSTATUS_EACCES=2, RECOVERY_PSTATUS_ENOSPC=3} recovery_pstatus_t;

typedef struct recovery_arg_struct {
    char diskName[MAX_DISK_NAME_LEN];
    int partNum;
    char path[MAX_PATH_LEN];
    char types[MAX_FILE_TYPE_COUNT][MAX_FILE_TYPE_STR_LEN];
    int typesCount;
} sRecArg;

typedef struct recovery_status_struct {
    char progress[MAX_BUF_LEN];
    char sectorRead[MAX_BUF_LEN];
    char fileFound[MAX_BUF_LEN];
    char elapsedTime[MAX_BUF_LEN];
    char estimatedTime[MAX_BUF_LEN];
    char fileRecoveredStr[MAX_FILE_TYPE_COUNT][MAX_FILE_TYPE_STR_LEN];
    int fileRecoveredNum[MAX_FILE_TYPE_COUNT];
    int fileRecoveredCount;
} sRecStatus;

void startRecovery(const char *diskName,
                   int partNum,
                   const char *path,
                   char types[][MAX_FILE_TYPE_STR_LEN],
                   int typesCount,
                   void (*cb_status_message)(sRecStatus *recStatus),
                   void (*cb_finish_message)(recovery_pstatus_t status));
void pauseRecovery();
void stopRecovery();
#endif
